﻿local VERSION = tonumber(("$Revision: 42203 $"):match("%d+"))

local QuestsFu = QuestsFu
local QuestsFu_Details = QuestsFu:NewModule("Details", "AceEvent-2.0", "AceHook-2.1", "AceConsole-2.0")
if QuestsFu.revision < VERSION then
	QuestsFu.version = "r" .. VERSION
	QuestsFu.revision = VERSION
	QuestsFu.date = ("$Date: 2007-06-29 05:04:18 -0400 (Fri, 29 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local tablet = AceLibrary("Tablet-2.0")
local quixote = AceLibrary("Quixote-1.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local crayon = AceLibrary("Crayon-2.0")
local abacus = AceLibrary("Abacus-2.0")

local L = AceLibrary("AceLocale-2.2"):new("QuestsFu_Details")
L:RegisterTranslations("enUS", function() return {
	["Quest details"] = true,
	["Options for the details pane"] = true,

	["Given by"] = true,
	["Required money: "] = true,
	["Description"] = true,
	["Rewards"] = true,
	["<not yet cached>"] = true,
	["Always receive:"] = true,
	["Spell:"] = true,
	["Money: "] = true,
	["Nothing."] = true,
	["Options"] = true,
	["Share"] = true,
	["Abandon"] = true,
	["Close"] = true,

	["%s in %s (%d,%d)"] = true,
	["bunch-of-directions"] = {
		"north",
		"northern",
		"west",
		"western",
		"east",
		"eastern",
		"south",
		"southern",
		"northwest",
		"northwestern",
		"northeast",
		"northeastern",
		"southwest",
		"southwestern",
		"southeast",
		"southeastern",
		"left",
		"right",
		"bottom",
		"top",
		"upriver",
		"downriver",
		"here",
		"near",
		"sides?",
		"caves?",
		"roads?",
		"islands?",
		"lakes?",
		"wanders?",
		"villages?",
		"coasts?",
		"altars?",
		"jungles?",
		"shores?",
		"ruins?",
		"city",
		"cities",
		"rivers?",
		"camps?",
		"houses?",
		"mines?",
		"arenas?",
		"mountains?",
		"edges?",
		"dig sites?",
		"beach",
		"beaches",
		"towns?",
		"garrisons?",
		"guard towers?",
		"towers?",
		"docks?",
		"dens?",
		"oasis",
		"oases",
	}
} end)

L:RegisterTranslations("deDE", function() return {
	["Quest details"] = "Quest Detail's",
	["Options for the details pane"] = "Optionen für das Quest Detail's Fenster.",

	["%s in %s (%d,%d)"] = "%s in %s (%d,%d)",
	["bunch-of-directions"] = {
		"norden",
		"nördlich",
		"westen",
		"westlich",
		"osten",
		"östlich",
		"süden",
		"südlich",
		"nordwest",
		"nordwestlich",
		"nordost",
		"nordöstlich",
		"südwest",
		"südwestlich",
		"südosten",
		"südöstlich",
		"links",
		"rechts",
		"unten",
		"oben",
		"seiten?",
		"höhlen?",
		"straßen?",
		"inseln?",
		"seen?",
		"wandernt?",
		"dörfer?",
		"küsten?",
		"altare?",
		"dschungel?",
		"ufer?",
		"ruinen?",
		"stadt",
		"städte",
		"flüsse?",
		"lager?",
		"häuser?",
		"minen?",
		"arenas?",
		"berge?",
		"ränder?",
		"ausgrabungsorte?",
		"strand",
		"strände",
		"orte?",
		"garnisonen?",
		"wachtürme?",
		"türme?",
		"docks?",
		"verstecke?",
		"oase",
		"oasen",
	}
} end)

L:RegisterTranslations("koKR", function() return {
	["Quest details"] = "퀘스트 상세한 설명",
	["Options for the details pane"] = "상세한 패널 옵션을 설정합니다.",

	["%s in %s (%d,%d)"] = "%s (%s) (%d,%d)",
	["bunch-of-directions"] = {
		"(%s?)(???)([^%a%d])",
		"(%s?)(???)([^%a%d])",
		"(%s?)(???)([^%a%d])",
		"(%s?)(???)([^%a%d])",
		"(%s?)(??)([^%a%d])",
		"(%s?)(??)([^%a%d])",
		"(%s?)(??)([^%a%d])",
		"(%s?)(??)([^%a%d])",
	}
} end)

L:RegisterTranslations("zhTW", function() return {
	["Quest details"] = "任務詳情",
	["Options for the details pane"] = "任務詳情框架設定",

	["Given by"] = "委託人",
	["Required money: "] = "需要金錢: ",
	["Description"] = "描述",
	["Rewards"] = "獎勵",
	["<not yet cached>"] = "<未知物品>",
	["Always receive:"] = "基本獎勵:",
	["Spell:"] = "法術:",
	["Money: "] = "金錢:",
	["Nothing."] = "無。",
	["Options"] = "選項",
	["Share"] = "分享",
	["Abandon"] = "放棄",
	["Close"] = "關閉",

	["%s in %s (%d,%d)"] = "%s 於 %s (%d,%d)",
    -- no clean way to translate.....
	["bunch-of-directions"] = {}
} end)

L:RegisterTranslations("esES", function() return {
	["Quest details"] = "Detalles de misión",
	["Options for the details pane"] = "Opciones para el panel de detalles",
	
	["%s in %s (%d,%d)"] = "%s en %s (%d,%d)",
	["bunch-of-directions"] = {
		"norte",
		"septentrional",
		"oeste",
		"occidental",
		"este",
		"oriental",
		"sur",
		"meridional",
		"noroeste",
		"noroccidental",
		"noreste",
		"nororiental",
		"suroeste",
		"sudoccidental",
		"sureste",
		"sudoriental",
		"izquierda",
		"derecha",
		"bajo",
		"sobre",
		"upriver",
		"downriver",
		"aquí",
		"cerca",
		"lados?",
		"cuevas?",
		"caminos?",
		"islas?",
		"lagos?",
		"deambula?",
		"pueblos?",
		"costas?",
		"altares?",
		"junglas?",
		"orillas?",
		"ruinas?",
		"ciudad",
		"ciudades",
		"ríos?",
		"campamentos?",
		"casas?",
		"minas?",
		"arenas?",
		"montañas?",
		"bordes?",
		"zonas de excavación?",
		"playa",
		"playas",
		"pueblos?",
		"guarniciones?",
		"torres de guardia?",
		"torres?",
		"puerto?",
		"guaridas?",
		"oasis",
	--	"oasis",
	}
} end)

do
	local args_enabled
	local args_disabled
	function QuestsFu_Details:OnInitialize()
		self.db = QuestsFu:AcquireDBNamespace("Details")
		QuestsFu:RegisterDefaults("Details", "profile", {
			data = {
				fontSizePercent=0.9, detached=true,
			},
			strata = 'HIGH',
			minWidth = 300,
			maxHeight = 800,
		})
		local arg_toggle = {
			name = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Enabled"],
			desc = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Suspend/resume this module."],
			type = 'toggle',
			order = -1,
			get = function() return QuestsFu:IsModuleActive(self) end,
			set = function()
				if tablet:IsRegistered('QuestsFu_Detail') then tablet:Close('QuestsFu_Detail') end
				QuestsFu:ToggleModuleActive(self)
			end
		}
		args_enabled = {
			strata = {
				name=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Strata"], type="text", desc=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Adjust the strata of this panel (takes effect after you reload your UI)"],
				get=function() return self.db.profile.strata end,
				set=function(t) self.db.profile.strata = t end,
				validate={'BACKGROUND', 'LOW', 'MEDIUM', 'HIGH', },
				order = 1,
			},
			maxHeight = {
				name=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Max height"], type="range", desc=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Adjust the maximum height of this panel, in pixels (takes effect after you reload your UI)"],
				get=function() return self.db.profile.maxHeight end,
				set=function(t) self.db.profile.maxHeight = t end,
				min=50, max=800, step=10,
				order = 1,
			},
			minWidth = {
				name=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Minimum width"], type="range", desc=AceLibrary("AceLocale-2.2"):new("QuestsFu")["Adjust the minimum width of this panel, in pixels (takes effect after you reload your UI)"],
				get=function() return self.db.profile.minWidth end,
				set=function(t) self.db.profile.minWidth = t end,
				min=50, max=800, step=10,
				order = 1,
			},
			--This one will look a little weird on the tablet right-click menu, as it'll be duplicating native functionality.  But it's totally worth it to stop people complaining.
			lock = {
				type = 'toggle', name = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Lock"],
				desc = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Lock or unlock this panel"],
				disabled = function() return not tablet:IsRegistered("QuestsFu_Detail") end,
				get = function() return (tablet:IsRegistered("QuestsFu_Detail") and tablet:IsLocked("QuestsFu_Detail")) end,
				set = function() tablet:ToggleLocked("QuestsFu_Detail") end,
				order = 1,
			},
			toggle = arg_toggle,
		}
		args_disabled = {
			toggle = arg_toggle,
		}
		QuestsFu.options.args.Details = {
			type = 'group', name = L["Quest details"], handler = QuestsFu,  --Handler here because we're going to reuse this table later on in the tablet registration.
			desc = L["Options for the details pane"], order = 99,
			args = args_disabled,
		}
	end

	function QuestsFu_Details:OnEnable()
		QuestsFu.options.args.Details.args = args_enabled
		self:RegisterEvent("Quixote_Quest_Lost")
		self:RegisterEvent("Quixote_Leaderboard_Update", "UpdateQuestDetail")
		self:Hook(QuestsFu, "ShowLog")

		self:UpdateQuestDetail()
	end

	function QuestsFu_Details:OnDisable()
		QuestsFu.options.args.Details.args = args_disabled
		tablet:Unregister("QuestsFu_Detail")
	end
end

function QuestsFu_Details:ShowLog(object, questid)
	if self.questid ~= questid then
		self.questid = questid
	else
		self.questid = nil
	end
	self:ScheduleEvent(self.UpdateQuestDetail, 0, self) --Schedule an event because tablet bugs out otherwise.

	--deliberately don't call the hook
end

function QuestsFu_Details:Quixote_Quest_Lost(name, id)
	if self.questid == id then
		self.questid = nil
		self:UpdateQuestDetail()
	end
end

local escapeDetector
function QuestsFu_Details:UpdateQuestDetail()
	if not tablet:IsRegistered('QuestsFu_Detail') then
		local qualitycolors = {
			[0] = "|cff9d9d9d",
			[1] = "|cffffffff",
			[2] = "|cff1eff00",
			[3] = "|cff0070dd",
			[4] = "|cffa335ee",
			[5] = "|cffff8000"
		}

		local questgiverPat = '^' .. L["%s in %s (%d,%d)"]:gsub("([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1"):gsub("%%%%s", "(.*)"):gsub("%%%%d", "(%%d+)") .. '$'

		local showingDescription = true
		local function itemClick(link)
			if IsControlKeyDown() then
				DressUpItemLink(link)
			elseif IsShiftKeyDown() then
				if not ChatFrameEditBox:IsVisible() then
					ChatFrameEditBox:Show()
				end
				ChatFrameEditBox:Insert(link)
			else
				ShowUIPanel(ItemRefTooltip)
				if not ItemRefTooltip:IsVisible() then
					ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
				end
				ItemRefTooltip:SetHyperlink(link)
			end
		end
		local function itemHover(link)
			GameTooltip:SetOwner(_G.this, 'ANCHOR_RIGHT', 7, -18)
			GameTooltip:SetHyperlink(link)
			if IsShiftKeyDown() then
				GameTooltip_ShowCompareItem()
			end
			GameTooltip:Show()
		end
		local function hideQuestDetail()
			self.questid = nil
			escapeDetector:Hide()
			self:UpdateQuestDetail()
		end
		local function toggleDescription()
			showingDescription = not showingDescription
			tablet:Refresh('QuestsFu_Detail')
		end
		local function abandonQuestPopup(questid)
			local startingQuestLogSelection = GetQuestLogSelection()
			SelectQuestLogEntry(questid)
			SetAbandonQuest()
			local items = GetAbandonQuestItems()
			if items then
				StaticPopup_Hide("ABANDON_QUEST")
				StaticPopup_Show("ABANDON_QUEST_WITH_ITEMS", GetAbandonQuestName(), items)
			else
				StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
				StaticPopup_Show("ABANDON_QUEST", GetAbandonQuestName())
			end
			SelectQuestLogEntry(startingQuestLogSelection)
		end
		-- by woodin 2007.2.9
		local directions = L["bunch-of-directions"]
		local colorizeQuestText, populateObjectiveWords, fixWords
		if GetLocale() == "koKR" then
			function colorizeQuestText(text)
			  -- this syntax is parsing of korean
			  -- group 0:all, 1: objective, 2: questgivers, 3:description,....
			  local parseFormats = {
						{group = 1,
						 patt  ="(%d+)([^%s%|])",
						 repl  = "|cff00ff00%1|r%2",
						}, -- Match numbers
						{group = 1,
						 patt  = "([?|?|?|?|?|?|?]+) ([^%s]+) ([^%s]+)(??)",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?|?|?|?|?|?]+) ([^%s]+)(??)",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([??|?]+) ([^%s]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([??|?]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?|?]+) ([^%s]+)(? )",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?]+) ([^%s]+) ([^%s]+)(? ?? )",
						 repl  = "%1 |cffffffff%2 %3|r%4",
						}, -- Match Quest finisher
						{group = 1,
						 patt  = "([?]+) ([^%s]+)(? ?? )",
						 repl  = "%1 |cffffffff%2|r%3",
						}, -- Match Quest finisher
				}
			  for k in ipairs(parseFormats) do
				text = text:gsub(parseFormats[k].patt, parseFormats[k].repl)
			  end
			  return text
			end
			function populateObjectiveWords() end
		else
			function colorizeQuestText(text, words)
				text = text:gsub("%f[%a%d%|](%d+)%f[^%a%d%|]", "|cff00ff00%1|r") -- Match numbers
				--This is copied in approach from MonkeyQuestLog, note.
				for _,word in ipairs(words) do
					text = text:gsub(word, "|cffffffff%1|r")
				end
				return text
			end

			function populateObjectiveWords(words, text)
				local last = nil
				for word in text:gmatch("(%S+)") do
					if last and last:find("[%w,%-]$") then
						local clean_word = word:match("(%u[%w'%-]+)")
						if clean_word then
							words[clean_word:lower()] = true
						end
					end
					last = word
				end
			end

			local function ignoreCaseHelper(v)
				return "[" .. v .. v:upper() .. "]"
			end
			local t = {}
			local i_byte = ('i'):byte()
			local apos_byte = ("'"):byte()
			function fixWords(words)
				for word in pairs(words) do
					t[word] = true
					words[word] = nil
				end
				for word in pairs(t) do
					t[word] = nil
					if word ~= "i" and (word:byte(1) ~= i_byte or word:byte(2) ~= apos_byte) then
						if not word:find("%?$") then
							if word:find("s$") then
								word = word .. "?"
							else
								word = word .. "s?"
							end
						end
						words[#words+1] = "%f[%w%d%|]" .. word:gsub("%f[%w](%w)", ignoreCaseHelper) .. "%f[^%w%d%|]"
					end
				end
			end
		end

		escapeDetector = CreateFrame("Frame", "QuestsFu_escapeDetector")
		escapeDetector:SetScript("OnHide", hideQuestDetail)
		table.insert(UISpecialFrames, escapeDetector:GetName())

		local words = {}

		tablet:Register('QuestsFu_Detail', 'detachedData', self.db.profile.data,
			'dontHook', true, 'hideWhenEmpty', true,-- 'showTitleWhenDetached', true,
			'minWidth', self.db.profile.minWidth, 'maxHeight', self.db.profile.maxHeight,
			'strata', self.db.profile.strata, 'cantAttach', true,
			'menu', function() dewdrop:FeedAceOptionsTable(QuestsFu.options.args.Details) end,
			'children', function()
				tablet:SetTitle("Detail")
				if self.questid then
					escapeDetector:Show()
					local startingQuestLogSelection = GetQuestLogSelection()
					SelectQuestLogEntry(self.questid)

					local title, level, tag, suggestedGroup, complete, nObjectives, zone, id = quixote:GetQuest(self.questid)
					local objective, description = quixote:GetQuestText(self.questid)

					--Title and objective:
					if not QuestsFu.db.profile.color.title then title = crayon:White(title) end
					if not QuestsFu.db.profile.color.level then level = crayon:White(questLevel) end
					local color = GetDifficultyColor(level)

					if QuestsFu:IsModuleActive("Givers") and questgiverPat and QuestsFu:GetModule("Givers").db.char.questgivers[title] then
						local giverName, giverZone = QuestsFu:GetModule("Givers").db.char.questgivers[title]:match(questgiverPat)
						if giverName then
							words[giverName:lower()] = true
							words[giverZone:lower()] = true
						end
					end
					populateObjectiveWords(words, objective)
					populateObjectiveWords(words, description)
					for _,v in ipairs(directions) do
						words[v] = true
					end
					if nObjectives > 0 then
						for i = 1, nObjectives do
							local objective = quixote:GetQuestStatusById(self.questid, i)
							if objective then
								words[objective:lower()] = true
							end
						end
					end
					fixWords(words)

					local cat = tablet:AddCategory('columns', 1, 'text', QuestsFu:MakeTag(level, tag)..title,
						'textR', (color and color.r) or 1, 'textG', (color and color.g) or 1, 'textB', (color and color.b) or 1,
						'size', tablet:GetHeaderFontSize(), 'justify', 'CENTER',
						'func', QuestsFu.QuestClick, 'arg1', QuestsFu, 'arg2', id) --Do this instead of closing the tablet because it seems permanently blank on its second open otherwise.
					if complete then
						cat:AddLine('text', complete, 'textR', (complete == AceLibrary("AceLocale-2.2"):new("QuestsFu")["(failed)"]) and 1 or 0, 'textG', (complete == AceLibrary("AceLocale-2.2"):new("QuestsFu")["(done)"]) and 1 or 0, 'textB', 0, 'justify', 'CENTER')
					end
					if suggestedGroup and suggestedGroup > 0 then
						cat:AddLine('text', (QUEST_SUGGESTED_GROUP_NUM):format(suggestedGroup), 'justify', 'CENTER')
					end
					cat:AddLine('text', colorizeQuestText(objective, words), 'wrap', true)

					--Leaderboard:
					if nObjectives > 0 then
						cat = tablet:AddCategory('columns', 2)
						for i=1,nObjectives do
							QuestsFu:AddLeaderboardToCategory(cat, self.questid, i, tablet:GetNormalFontSize(), 0)
						end
					end

					--Given by?
					if QuestsFu:IsModuleActive("Givers") then
						local giver = QuestsFu:GetModule("Givers").db.char.questgivers[title]
						if giver then
							cat = tablet:AddCategory('columns', 2, 'text', L["Given by"])
							cat:AddLine('text', colorizeQuestText(giver, words), 'indentation', 2)
						end
					end

					--Requires money?
					if GetQuestLogRequiredMoney() > 0 then
						cat = tablet:AddCategory('columns', 2, 'text', L["Required money: "]..abacus:FormatMoneyFull(GetQuestLogRequiredMoney()), 'showWithoutChildren', true)
					end

					--Description:
					cat = tablet:AddCategory('columns', 1, 'text', L["Description"], 'func', toggleDescription, 'showWithoutChildren', true,
						'checked', true, 'hasCheck', true, 'checkIcon', (not showingDescription) and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up")
					if showingDescription then
						cat:AddLine('text', colorizeQuestText(description, words), 'wrap', true)
					end
					for i in ipairs(words) do
						words[i] = nil
					end

					--Rewards:
					cat = tablet:AddCategory('columns', 2, 'text', L["Rewards"])
					local numChoices = GetNumQuestLogChoices(self.questid) -- The ones you choose from
					local numRewards = GetNumQuestLogRewards(self.questid) -- The ones you always get
					local rewardMoney = GetQuestLogRewardMoney(self.questid) -- Moolah!
					local rewardSpellTexture, rewardSpellName = GetQuestLogRewardSpell() -- Sometimes there's a spell

					if numChoices > 0 or numRewards > 0 or rewardMoney > 0 then
						if numChoices > 0 then
							cat:AddLine('text', "Choose from:", 'indentation', 2)
							for i=1, numChoices, 1 do
								local name, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(i)
								cat:AddLine('text', (quality and qualitycolors[quality] or '')..'['..(name or L['<not yet cached>'])..']'..((numItems > 1) and (" x"..numItems) or ""), 'indentation', 4,
									'checked', true, 'hasCheck', true, 'checkIcon', texture,
									'func', itemClick, 'arg1', GetQuestLogItemLink('choice', i),
									'onEnterFunc', itemHover, 'onEnterArg1', GetQuestLogItemLink('choice', i),
									'onLeaveFunc', GameTooltip.Hide, 'onLeaveArg1', GameTooltip)
							end
						end
						if numRewards > 0 then
							cat:AddLine('text', L["Always receive:"], 'indentation', 2)
							for i=1, numRewards, 1 do
								local name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(i)
								cat:AddLine('text', (quality and qualitycolors[quality] or '')..'['..(name or L['<not yet cached>'])..']'..((numItems > 1) and (" x"..numItems) or ""), 'indentation', 4,
									'checked', true, 'hasCheck', true, 'checkIcon', texture,
									'func', itemClick, 'arg1', GetQuestLogItemLink('reward', i),
									'onEnterFunc', itemHover, 'onEnterArg1', GetQuestLogItemLink('reward', i),
									'onLeaveFunc', GameTooltip.Hide, 'onLeaveArg1', GameTooltip)
							end
						end
						if rewardSpellTexture then
							cat:AddLine('text', L["Spell:"], 'indentation', 2)
							cat:AddLine('text', rewardSpellName, 'indentation', 4,
								'checked', true, 'hasCheck', true, 'checkIcon', rewardSpellTexture)
						end
						if rewardMoney > 0 then
							cat:AddLine('text', L['Money: ']..abacus:FormatMoneyFull(rewardMoney, true), 'indentation', 2)
						end
					else
						cat:AddLine('text', L["Nothing."], 'indentation', 2)
					end

					cat = tablet:AddCategory('columns', 1, 'text', L["Options"])
					--Shareable:
					if GetQuestLogPushable() then
						cat:AddLine('text', L["Share"], 'func', QuestsFu.ShareQuest, 'arg1', QuestsFu, 'arg2', self.questid)
					end
					cat:AddLine('text', L["Abandon"], 'func', abandonQuestPopup, 'arg1', self.questid)
					cat:AddLine('text', L["Close"], 'func', hideQuestDetail, 'textR', 1, 'textG', 0, 'textB', 0, 'justify', 'RIGHT')

					SelectQuestLogEntry(startingQuestLogSelection)
				end
			end)
		tablet:Open('QuestsFu_Detail')
	end
	tablet:Refresh('QuestsFu_Detail')
end
